package com.xxp.library.Dialog;

import android.app.Dialog;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.ImageView;
import android.widget.TextView;

import com.xxp.library.R;


public class StyleProgressDialog {

	/**
	 * 得到自定义的progressDialog
	 * 
	 * @param context
	 * @param msg
	 * @return
	 */


	public static Dialog showLoadingDialog(String msg, Context context) {

		LayoutInflater inflater = LayoutInflater.from(context);
		View v = inflater.inflate(R.layout.loading_dialog, null);// 得到加载view
		// RelativeLayout layout = (LinearLayout)
		// RelativeLayout.findViewById(R.id.dialog_view);// 加载布局
		// main.xml中的ImageViewStyleProgressDialogStyleProgressDialogStyleProgressDialog
		final ImageView spaceshipImage = (ImageView) v.findViewById(R.id.img);
		TextView tipTextView = (TextView) v.findViewById(R.id.tipTextView);// 提示文字
		// 加载动画
		final Animation hyperspaceJumpAnimation = AnimationUtils.loadAnimation(
				context, R.anim.load_animation);
		// // 使用ImageView显示动画
		// spaceshipImage.startAnimation(hyperspaceJumpAnimation);
		tipTextView.setText(msg);// 设置加载信息

		final Dialog loadingDialog = new Dialog(context, R.style.DialogTheme) {
			@Override
			public void show() {
				// TODO Auto-generated method stub
				try {
					if (!isShowing())
						super.show();
					spaceshipImage.startAnimation(hyperspaceJumpAnimation);
				} catch (Exception ex) {
				}

			}
		};
		loadingDialog.setCancelable(false);// 不可以用“返回键”取消
		loadingDialog.setContentView(v);// 设置布局
		return loadingDialog;

	}
}
