package com.xxp.library.Dialog;

import android.app.Dialog;
import android.content.Context;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.view.Gravity;
import android.view.ViewGroup;
import android.view.Window;
import android.view.WindowManager;

import androidx.annotation.NonNull;

import com.xxp.library.R;


public abstract class xxBaseDialog extends Dialog {
  public   DialogSet set;

    public xxBaseDialog(@NonNull Context context) {
        super(context, R.style.DialogTheme);
        set = InitView();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setContentView(set.getLayout());
        setCanceledOnTouchOutside(set.isOutSite());
        setCancelable(set.isCancle());
        getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        getWindow().getDecorView().setPadding(0, 0, 0, 0);
//        window.setAttributes(params);
        getWindow().setLayout(set.width, set.hight);
        InitData();

    }

    public abstract DialogSet InitView();

    public abstract void InitData();

    public class DialogSet {
        int layout;
        boolean outSite;
        int gravity;
        boolean cancle;
        int width;
        int hight;

        public DialogSet(int layout, boolean outSide, int gravity, boolean cancle) {
            this.layout = layout;
            this.outSite = outSide;
            this.gravity = gravity;
            this.cancle = cancle;
            this.width = WindowManager.LayoutParams.MATCH_PARENT;
            this.hight = WindowManager.LayoutParams.WRAP_CONTENT;
        }

        public DialogSet(int layout, boolean outSide, int gravity, boolean cancle, int w, int h) {
            this.layout = layout;
            this.outSite = outSide;
            this.gravity = gravity;
            this.cancle = cancle;
            this.width = w;
            this.hight = h;
        }

        public boolean isCancle() {
            return cancle;
        }

        public void setCancle(boolean cancle) {
            this.cancle = cancle;
        }

        public int getLayout() {
            return layout;
        }

        public void setLayout(int layout) {
            this.layout = layout;
        }

        public boolean isOutSite() {
            return outSite;
        }

        public void setOutSite(boolean outSite) {
            this.outSite = outSite;
        }

        public int getGravity() {
            return gravity;
        }

        public void setGravity(int gravity) {
            this.gravity = gravity;
        }
    }

    @Override
    public void show() {
        Window window = getWindow();
        //设置弹出位置
        window.setGravity(set.getGravity());

//        window.setBackgroundDrawableResource(android.R.color.white);

        //设置弹出动画
        //window.setWindowAnimations(R.style.main_menu_animStyle);
        //设置对话框大小
//        WindowManager.LayoutParams params = getWindow().getAttributes();
//        params.width = WindowManager.LayoutParams.MATCH_PARENT;
//        params.height = WindowManager.LayoutParams.WRAP_CONTENT;
        window.setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        window.getDecorView().setPadding(0, 0, 0, 0);
//        window.setAttributes(params);
        window.setLayout(WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.WRAP_CONTENT);
        super.show();
    }
}
