package com.xxp.library.View;

import android.content.Context;
import android.content.res.TypedArray;
import android.graphics.drawable.Drawable;
import android.util.AttributeSet;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.annotation.Nullable;

import com.xxp.library.R;

public class FoldTitleLayout extends RelativeLayout {

    TextView tv_title;
    ImageView iv_states;
    TypedArray attrsArray;
    Drawable back;
    //false 收起，ture 展示
    boolean showStates = false;
    setOnChangeLisener lisener;
    View self;

    public FoldTitleLayout(Context context) {
        super(context);
        self = this;
        InitView(null);
    }

    public FoldTitleLayout(Context context, @Nullable AttributeSet attrs) {
        super(context, attrs);
        self = this;
        InitView(attrs);
    }

    public FoldTitleLayout(Context context, @Nullable AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
        self = this;
        InitView(attrs);
    }


    public void InitView(AttributeSet attributeSet) {
        View view = LayoutInflater.from(getContext()).inflate(R.layout.v_fold_title, this, true);
        back = getBackground();
        tv_title = view.findViewById(R.id.tv_title);
        iv_states = view.findViewById(R.id.iv_states);
        if (attributeSet != null) {
            attrsArray = getContext().obtainStyledAttributes(attributeSet, R.styleable.FoldTitleLayout);
            // TypedArray attrsview = getContext().obtainStyledAttributes(attributeSet, R.styleable.View);
            showStates = attrsArray.getBoolean(R.styleable.FoldTitleLayout_showStates, false);
            tv_title.setText(attrsArray.getString(R.styleable.FoldTitleLayout_title));
            tv_title.setTextColor(attrsArray.getColor(R.styleable.FoldTitleLayout_textColor, getResources().getColor(R.color.text_black)));
            if (showStates) {
                iv_states.setImageDrawable(getResources().getDrawable(R.drawable.content_icon_shangjiantou));
//                setBackground(back);
            } else {
                iv_states.setImageDrawable(getResources().getDrawable(R.drawable.content_icon_xiajiantou));
                if (0 != attrsArray.getResourceId(R.styleable.FoldTitleLayout_packBackgroud, 0)) {
//                    setBackground(getResources().getDrawable(attrsArray.getResourceId(R.styleable.FoldTitleLayout_packBackgroud, 0)));
                }

            }


            view.setOnClickListener(new OnClickListener() {
                @Override
                public void onClick(View v) {

                    if (showStates) {

                        showStates = false;
                        iv_states.setImageDrawable(getResources().getDrawable(R.drawable.content_icon_xiajiantou));
                        if (0 != attrsArray.getResourceId(R.styleable.FoldTitleLayout_packBackgroud, 0)) {
//                            setBackground(getResources().getDrawable(attrsArray.getResourceId(R.styleable.FoldTitleLayout_packBackgroud, 0)));
                        }
                    } else {

                        showStates = true;
                        iv_states.setImageDrawable(getResources().getDrawable(R.drawable.content_icon_shangjiantou));
                        setBackground(back);

                    }
                    if (lisener!=null)
                    {
                        lisener.onChange(self, showStates);
                    }

                }
            });
        }

    }

    public void setTitle(String title) {
        tv_title.setText(title);

    }

    public String getTitle()
    {
        return tv_title.getText().toString();
    }


    public void setShowState(boolean show) {
        showStates = show;
        if (showStates) {
            iv_states.setImageDrawable(getResources().getDrawable(R.drawable.content_icon_shangjiantou));
            setBackground(back);
        } else {
            iv_states.setImageDrawable(getResources().getDrawable(R.drawable.content_icon_xiajiantou));
            if (0 != attrsArray.getResourceId(R.styleable.FoldTitleLayout_packBackgroud, 0)) {
                setBackground(getResources().getDrawable(attrsArray.getResourceId(R.styleable.FoldTitleLayout_packBackgroud, 0)));
            }

        }

    }


    public void setChangeLisener(setOnChangeLisener lisener) {
        this.lisener = lisener;

    }

    public interface setOnChangeLisener {
        public void onChange(View view, boolean showStates);
    }

}
