package com.xxp.library.View.ViewUtils;

import android.graphics.Rect;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.zhy.autolayout.utils.AutoUtils;

public class LinearItemDecoration extends RecyclerView.ItemDecoration {
    private int space;

    public LinearItemDecoration(int space) {
        this.space = space;
    }


    @Override
    public void getItemOffsets(@NonNull Rect outRect, @NonNull View view, @NonNull RecyclerView parent, @NonNull RecyclerView.State state) {
        super.getItemOffsets(outRect, view, parent, state);
        GridLayoutManager manager = (GridLayoutManager) parent.getLayoutManager();
        int spanCount = manager.getSpanCount();
        int lineCount = (int) Math.ceil(Double.valueOf(parent.getAdapter().getItemCount()) / spanCount);
        int row = (int) Math.ceil(Double.valueOf(parent.getChildAdapterPosition(view)+1) / spanCount);
        if (row < lineCount) {
            int bom = (int) Math.round(space * AutoUtils.getPercentHeight1px() + 0.5);
            outRect.bottom = bom;
        } else {
            outRect.bottom = 0;
        }
//        int bom= (int) Math.round(space*AutoUtils.getPercentHeight1px()+0.5);
//        outRect.bottom =bom ;
    }
}
