package com.xxp.library.httpUtil;

import android.util.Log;

import com.google.gson.Gson;

import org.json.JSONObject;

import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Observable;

import okhttp3.Interceptor;
import okhttp3.MediaType;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;
import okhttp3.ResponseBody;
import okhttp3.logging.HttpLoggingInterceptor;
import okio.Buffer;
import okio.BufferedSource;
import okio.Utf8;
import rx.Scheduler;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;


public class InterceptorUtil {

    public static final String TAG = "CourtHttp";

    public static String Interceptor_TOKEN = "";

    /**
     * 日志拦截器
     *
     * @return
     */
    public static HttpLoggingInterceptor LogInterceptor() {
        return new HttpLoggingInterceptor(new HttpLoggingInterceptor.Logger() {
            @Override
            public void log(String message) {
                Log.w(TAG, message);
            }
        }).setLevel(HttpLoggingInterceptor.Level.BODY);
    }


    public static Interceptor HeaderInterceptor() {
        return new Interceptor() {
            @Override
            public Response intercept(Chain chain) throws IOException {


                Request.Builder builder = chain.request().newBuilder();
                if (!Interceptor_TOKEN.equals("")) {
                    builder.addHeader("Authorization", Interceptor_TOKEN);
                }
                builder.addHeader("clientType", "fy_authority");
                Request request = builder.build();

                Response response = chain.proceed(request);
                ResponseBody responseBody = response.body();
                BufferedSource source = responseBody.source();
                source.request(Long.MAX_VALUE); // Buffer the entire body.
                Buffer buffer = source.buffer();
                Charset UTF8 = Charset.forName("UTF-8");
                JSONObject bodyJson = null;
                try {
                    bodyJson = new JSONObject(buffer.clone().readString(UTF8));
                    if (bodyJson.get("code").equals("E004")) {
                        getNewToken();
                        builder.addHeader("Authorization", Interceptor_TOKEN);
                        request = builder.build();
                        response = chain.proceed(request);
                    } else if (bodyJson.get("token") != null && !bodyJson.get("token").toString().equals("")) {
                        Interceptor_TOKEN = "Bearer " + bodyJson.get("token").toString();
//                        Interceptor_TOKEN =bodyJson.get("token").toString();
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }

                return response;
            }


        };
    }


    public static void getNewToken() {
        final String[] token = {""};
        ApiProtocal lp = (ApiProtocal) new ApiClient(ApiProtocal.class).lp;
        rx.Observable<BaseResponse<String>> observable = lp.getToken(Interceptor_TOKEN.replace("Bearer ", ""));
        observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new xxSubscriber<String>() {
            @Override
            public void onSuccess(String resultBean) {
                Interceptor_TOKEN = "Bearer " + resultBean;
//                 Interceptor_TOKEN = resultBean;
            }

            @Override
            public void onError(String Error) {

            }
        });


    }


}
