package com.xxp.library.util;

import android.os.Build;
import android.util.Base64;
import android.util.Log;

import androidx.annotation.RequiresApi;


import java.io.IOException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


public class CySM4Util {


    private String secretKey;

    private String iv = "";

    public boolean hexString = false;


    public String encryptData_ECB(String plainText) {
        try {
            CySM4_Context ctx = new CySM4_Context();
            ctx.isPadding = true;
            ctx.mode = CySM4.SM4_ENCRYPT;

            byte[] keyBytes;
            if (hexString) {
                keyBytes = CyByteUtil.hexStringToBytes(secretKey);
            } else {
                keyBytes = secretKey.getBytes();
            }

            CySM4 sm4 = new CySM4();
            sm4.sm4_setkey_enc(ctx, keyBytes);
            byte[] encrypted = sm4.sm4_crypt_ecb(ctx, plainText.getBytes("UTF-8"));
            String cipherText = new BASE64Encoder().encode(encrypted);
           /* if (Build.VERSION.SDK_INT >=Build.VERSION_CODES.O)
            {
               Base64.Encoder encoder = Base64.getEncoder();
                cipherText = encoder.encodeToString(encrypted);

            }else
            {
                 cipherText =   Base64Encoder.encode(encrypted);
            }*/

            if (cipherText != null && cipherText.trim().length() > 0) {
                Pattern p = Pattern.compile("\\s*|\t|\r|\n");
                Matcher m = p.matcher(cipherText);
                cipherText = m.replaceAll("");
            }
            return cipherText;
        } catch (Exception e) {
            return "";
        }
    }

    public String decryptData_ECB(String cipherText) {
        try {
            CySM4_Context ctx = new CySM4_Context();
            ctx.isPadding = true;
            ctx.mode = CySM4.SM4_DECRYPT;

            byte[] keyBytes;
            if (hexString) {
                keyBytes = CyByteUtil.hexStringToBytes(secretKey);
            } else {
                keyBytes = secretKey.getBytes();
            }

            CySM4 sm4 = new CySM4();
            sm4.sm4_setkey_dec(ctx, keyBytes);
            byte[] decrypted = sm4.sm4_crypt_ecb(ctx, new BASE64Decoder().decodeBuffer(cipherText));
            return new String(decrypted, "UTF-8");
        } catch (Exception e) {
            return e.toString();

        }
    }

    public String encryptData_CBC(String plainText) {
        try {
            CySM4_Context ctx = new CySM4_Context();
            ctx.isPadding = true;
            ctx.mode = CySM4.SM4_ENCRYPT;

            byte[] keyBytes;
            byte[] ivBytes;
            if (hexString) {
                keyBytes = CyByteUtil.hexStringToBytes(secretKey);
                ivBytes = CyByteUtil.hexStringToBytes(iv);
            } else {
                keyBytes = secretKey.getBytes();
                ivBytes = iv.getBytes();
            }

            CySM4 sm4 = new CySM4();
            sm4.sm4_setkey_enc(ctx, keyBytes);
            byte[] encrypted = sm4.sm4_crypt_cbc(ctx, ivBytes, plainText.getBytes("UTF-8"));
            String cipherText = new BASE64Encoder().encode(encrypted);
            if (cipherText != null && cipherText.trim().length() > 0) {
                Pattern p = Pattern.compile("\\s*|\t|\r|\n");
                Matcher m = p.matcher(cipherText);
                cipherText = m.replaceAll("");
            }
            return cipherText;
        } catch (Exception e) {
            return e.toString();

        }
    }

    public String decryptData_CBC(String cipherText) {
        try {
            CySM4_Context ctx = new CySM4_Context();
            ctx.isPadding = true;
            ctx.mode = CySM4.SM4_DECRYPT;

            byte[] keyBytes;
            byte[] ivBytes;
            if (hexString) {
                keyBytes = CyByteUtil.hexStringToBytes(secretKey);
                ivBytes = CyByteUtil.hexStringToBytes(iv);
            } else {
                keyBytes = secretKey.getBytes();
                ivBytes = iv.getBytes();
            }

            CySM4 sm4 = new CySM4();
            sm4.sm4_setkey_dec(ctx, keyBytes);
            byte[] decrypted = sm4.sm4_crypt_ecb(ctx, new BASE64Decoder().decodeBuffer(cipherText));
            return new String(decrypted, "UTF-8");
        } catch (Exception e) {
            return e.toString();

        }
    }

    public static String main(String args) {


        CySM4Util sm4 = new CySM4Util();
        sm4.secretKey = "FFFAAA333666DDDB";
        sm4.hexString = false;
        //log.info("ECB模式加密");
        String cipherText = sm4.encryptData_ECB(args);
        /* String cipherSmText = sm4.encryptData_ECB(smTest);*/
        // log.info("------测试密文------: " + cipherSmText);
        // log.info("密文: " + cipherText);
        String plainText = sm4.decryptData_ECB(cipherText);
        // log.info("明文: " + plainText);
        Log.e("明文", plainText);
        return cipherText;

    }
}
